<template>
    <div>
        <section class="hero">
            <div class="hero-body">
                <p class="title">
                    Scoreboards
                </p>
            </div>
        </section>
        <section class="section">
            <h3 class="title">Current standings</h3>
            <div v-if="scoreboardIndices.length !== 0">
                <b-collapse
                    v-for="(board, i) in scoreboardIndices"
                    :key="i"
                    class="card"
                    animation="slide"
                    :open="false"
                    :aria-id="i.toString()">
                   <template #trigger="props">
                       <div
                           class="card-header"
                           role="button"
                           @click="getScoreboard(i, board.id)"
                           :aria-controls="i">
                           <p class="card-header-title">
                               Scores updated {{ Intl.DateTimeFormat([], { dateStyle: 'medium', timeStyle: 'short' }).format(new Date(board.created_at)) }}
                           </p>
                           <a class="card-header-icon">
                               <b-icon
                                   :icon="props.open ? 'caret-up' : 'caret-down'">
                               </b-icon>
                           </a>
                       </div>
                   </template>
                   <div class="card-content">
                       <div v-if="loadStates[i]">
                           <b-table
                               :data="scoreboardData[i.toString()].data"
                               :columns="scoreboardData[i.toString()].columns"
                           ></b-table>
                       </div>
                       <p v-else>
                           Scoreboard loading...
                       </p>
                   </div>
                   <footer class="card-footer">
                       <a class="card-footer-item" :href="`/api/scoreboards/download/csv/${board.id}`">Download as CSV</a>
                   </footer>
                </b-collapse>
            </div>
            <div v-else>
                <p>
                    No scoreboards are available at this time.
                </p>
            </div>
        </section>
    </div>
</template>

<script>
 export default {
     name: 'Scoreboard',
     data() {
         return {
             scoreboardData: {},
             scoreboardIndices: [],  // array of objects with keys 'id' and 'created_at'
             loadStates: {}  // object with keys as indices and values boolean
         }
     },
     methods: {
         getScoreboardIds() {
             fetch('/api/scoreboards/download/index')
                 .then((response) => {
                     if (response.ok) {
                         response.json()
                                 .then((json) => {
                                     this.scoreboardIndices = json.boards
                                     for (let i = 0; i < this.scoreboardIndices.length; i++) {
                                         this.loadStates[i] = false
                                     }
                                 })
                                 .catch((e) => { console.error(e) })
                     }
                 })
         },
         getScoreboard(i, id) {
             // insert the data for scoreboard "id" at key "i" in this.scoreboardData
             if (this.scoreboardData[i.toString()]) {
                 // do nothing if it's already loaded
                 return
             }
             fetch(`/api/scoreboards/download/array/${id}`)
                 .then((response) => {
                     if (response.ok) {
                         response.json()
                                 .then((json) => {
                                     let data = json.data
                                     // generate columns
                                     let columns = []
                                     for (let column in data[0]) {
                                         // data[0] is an object (the first row) that looks like
                                         // { 'column': 'val', 'column': val }
                                         columns.push({ field: column, label: column })
                                     }
                                     this.scoreboardData[i.toString()] = {}
                                     this.scoreboardData[i.toString()].columns = columns
                                     // set the data
                                     this.scoreboardData[i.toString()].data = data
                                     // render
                                     this.loadStates[i] = true
                                     // this is ugly but vue has trouble reacting to nested
                                     // objects, and we need to nest bc we don't know how many
                                     // leaderboards there are
                                     this.$forceUpdate()
                                 })
                                 .catch((e) => { console.error(e) })
                     }
                 })
                 .catch((e) => { console.error(e) })
         }
     },
     mounted() {
         this.getScoreboardIds()
     }
 }
</script>
